<!--****************************************************************************
* $Id: README.md 72ef34e 2022-04-09 11:40:46 -0700 sthames42 $
*****************************************************************************-->
# Building a NuGet Package Using npm

This document describes how to create and maintain a [Nuget Package][NuGet] using 
[MSBuild][msbuild-package] and [Gulp]. Package [versioning][semver] is handled using [npm].

<!--===========================================-->
<!-- Update this TOC using `npx markdown-toc`. -->
<!--===========================================-->

<!-- toc -->

- [Overview](#overview)
    + [Source Link](#source-link)
    + [Doxygen and Intellisense](#doxygen-and-intellisense)
- [Requirements](#requirements)
- [Creating the Package](#creating-the-package)
  * [Create a New Solution and Library Project](#create-a-new-solution-and-library-project)
  * [Convert an Existing Library Project](#convert-an-existing-library-project)
  * [Modify the Project File](#modify-the-project-file)
  * [Copy and Configure Support Files](#copy-and-configure-support-files)
    + [Solution Files](#solution-files)
    + [Library Project Files](#library-project-files)
  * [Install Support Packages](#install-support-packages)
  * [Install `Tests` project for unit tests (optional)](#install-tests-project-for-unit-tests-optional)
  * [Install **`Docs`** project for Doxygen website (optional)](#install-docs-project-for-doxygen-website-optional)
- [Building and Publishing](#building-and-publishing)
    + [Preparation](#preparation)
    + [Build Commands](#build-commands)
    + [TL;DR](#tldr)
- [References](#references)

<!-- tocstop -->

## Overview

In addition to simply creating a NuGet package, the objective here is to provide a simple process 
for creating and publishing new versions of the library and to provide source code availability 
for debugging.

Debug symbols are stored in [`.pdb` files][pdb-files] generated by the compiler and map the 
executable program code to the source code. The debugger can then show the source file location for 
a breakpoint. `.pdb` files are not typically included with NuGet packages so [Symbol Servers][symbol-servers] 
were created to provide a location where [Visual Studio could download the `.pdb` files of a 
compiled project, while debugging][vs-symbol-servers], and retrieve the source code from the local 
machine, a [Source Server][vs-source-servers], or [some other location][vs-source-file-paths].

However, configuration of a package to use a source server is somewhat arduous and, as of this
writing, [GitLab doesn't fully support symbol servers for NuGet registries](https://gitlab.com/gitlab-org/gitlab/-/issues/342157).
In addition, NuGet packages are built in "Release" mode and compiler optimizations limit the 
debugging facility to source code review, with limited capability for setting breakpoints and 
viewing the contents of variables.


#### Source Link

The procedure builds a library using [Source Link][source-link] to enable source code navigation into 
the library while debugging a referencing assembly. The actual repository locations of the package 
source code files are written into the `.pdb` file(s) so the debugger can retrieve them. Source 
Link configuration is far simpler than configuring a source server.

The package `.nupkg` file includes both the Release and Debug versions of the library. When the 
referencing assembly is built in Debug mode, the library Debug build files, including the 
`.pdb` file with Source Link references, are copied to the build output folder for debugging. When 
the project is built in "Release" mode, the Release version of the NuGet package library is copied, instead.

It is not possible, [currently](https://github.com/dotnet/roslyn/issues/24349), to navigate to the 
source code with the "Go to definition" option in Visual Studio.


#### Doxygen and Intellisense

[Doxygen] is configured to create a library reference website based on the code documentation in the 
source files. It provides much greater flexibility in documenting code than the XML style understood 
by Visual Studio.

The tools described here include how to configure the [Doxygen] documentation 
generator to build a website from the comments within the library code as well as how to create a
library [Intellisense] file from the Doxygen output. 

Both the Doxygen website and the Intellisense generation are a work in progress. The resulting 
Intellisense file created is [not yet fully supported by Visual Studio](https://stackoverflow.com/a/71357159/2245849).


## Requirements

NuGet packages have the following requirements.

  * **Library Dependencies must refer to NuGet Packages**  
    All library dependencies must be resolved with other NuGet packages.

  * **Nuget package dependency references must be in `ProjectReference` Format**  
    Nuget package references in must be [`PackageReference`][PackageReference] items. 
    [`packages.config`][packages.config] may not be used.
 
  * **Project file must be an SDK-Style Project**  
    [SDK-Style][sdk-style] projects are much [slimmer and more flexible][demystify-sdk] than the 
    original and can be edited without unloading the project. In addition, the Nuget Package 
    properties are stored in the project file instead of `.nuspec` file.


## Creating the Package

The library must be in a subfolder of the solution folder, named for the library. The solution folder can be called 
anything. But, for the purposes of these directions, both folders are named for the library.

Given the existing .Net library project called `MyLibrary`, the NuGet package solution must be structured as:

    MyLibrary/
    |-- MyLibrary/
    |   |   MyLibrary.csproj
    |   |   ... Library Source Files ...
    |   |   Build.targets.tt
    |   |   Package.targets
    |   |   Version.targets
    |-- Docs/
    |   |   Docs.shproj
    |   |   ... Doxygen Configuration Files ...
    |-- Tests/
    |   |   Tests.csproj   
    |   MyLibrary.sln
    |   gulpfile.js
    |   package.json
    |   README.md


### Create a New Solution and Library Project

  1) Using [version 5.0][dotnet-download] of the [.NET CLI][dotnet-cli], these commands will create a
     new solution and class library project in the [SDK-Style] for the .NET 5.0 platform.

     ```bash
     dotnet new sln -o MyLibrary
     cd MyLibrary
     dotnet new classlib -lang C# -o MyLibrary
     cd ..
     dotnet sln add MyLibrary/MyLibrary.csproj
     ```

  2) Load the solution into Visual Studio.
  

### Convert an Existing Library Project

  - [Migrate to SDK Project Format](https://www.michaeltaylorp3.net/migrating-to-sdk-project-format/) 
  - [Moving to SDK-Style projects and package references](https://hermit.no/moving-to-sdk-style-projects-and-package-references-in-visual-studio-part-2/)
  
  1) If the project and solution exist in the same folder,
 
     1) Move the library to a subfolder with the same name. Include the project file and all files
        included by that file.

     1) Modify `.sln` file to load the library project (`.csproj` file) from the subfolder.
  
  1) Load the solution into Visual Studio.
  
  1) If there any 3rd-party library references to local `.dll` files, remove them, find a NuGet feed 
     that provides the same versions, and install them with the [Nuget Package Manager][install-package].

     ***If any required library can't be found in a NuGet feed, this process can't continue.***
  
  1) [Migrate packages.config to PackageReference](https://docs.microsoft.com/en-us/nuget/consume-packages/migrate-packages-config-to-package-reference)
  
     - In Solution Explorer, select **Migrate packages.config to PackageReference** from the right-click
       context menu of `packages.config` or `References`.  
     
       ***If the option does not appear, [try this](https://github.com/NuGet/docs.microsoft.com-nuget/issues/860#issuecomment-409207305).***

  1) Clean any temporary and output directories.


### Modify the Project File

  1) Unload the project.
  
  1) In the **Solution Explorer** project context menu, select **Edit Project File**. 
       
  1) Replace the `<?xml...>` tag (if found) and `<Project...>` element with the following and set 
     the appropriate values.
     ```xml
     <Project Sdk="Microsoft.NET.Sdk">
         <PropertyGroup>
             <OutputType>Library</OutputType>
             <RootNamespace>MyLibrary</RootNamespace>
             <TargetFramework>net452</TargetFramework>
             <Platforms>AnyCPU</Platforms>
             <NoWarn>1701;1702;1591</NoWarn>
                
             <AssemblyTitle>My Library</AssemblyTitle>
             <Description>My very favorite things to do in code.</Description>
             <Company>My Company</Company>
             <Copyright>Copyright (c) MyCompany 2000</Copyright>
             <Version>9.9.9</Version>
         </PropertyGroup>
     
         <Import Project="$(MSBuildProjectDirectory)\Package.targets" />
     
         ... Additional Configuration ...
     
     </Project>
     ```
     
     - **`OutputType`** and **`Version`** must remain as shown.
     - **`RootNamespace`**, **`AssemblyTitle`**, **`Description`**, **`Company`**, and 
       **`Copyright`** must be set as appropriate for the package.
     - **`TargetFramework`** must be `net452` as a minimum.
     - **`Platforms`** should be set to `AnyCPU` unless specific targeting is required. 
             
     The **`<Import...>`** tag loads the remaining required configuration settings.
  
  1) Remove all remaining **`<PropertyGroup>`** sections.
          
  1) By default, SDK-Style projects include all files, so:
                
      - Remove **`<Content Include="...">`** and **`<Compile Include="...">`** tags from 
        **`<ItemGroup>`** sections.
             
      - Keep **`<Reference Include="...">`** tags as they refer to system libraries.
  
      - Remove **`<EmbeddedResource Include="...">`** tags for `.resx` files which will be included 
        by default. Keep them for embedded files that are not automatically recogized.

        **Embedded Resource Notes**

        Since the .NET Core SDK 3.0, Non-string resources require the [System.Resources.Extensions](https://www.nuget.org/packages/System.Resources.Extensions/)
        NuGet package and [`<GenerateResourceUsePreserializedResources>`](https://learn.microsoft.com/en-us/visualstudio/msbuild/generateresource-task#remarks) 
        must be `true`. From the documentation:

        > This property is set to true by default in .NET Core projects and projects that use .NET 5 or later. 
        > You can set `<GenerateResourceUsePreserializedResources>` to true to allow the .NET SDK to build 
        > projects targeting .NET Framework 4.6.1 or later that use non-string resources. 
        > The assembly System.Resources.Extensions must be available at runtime. It is available in .NET Core 3.0 
        > and later and .NET 5 and later, and can be used in .NET Framework 4.6.1 or later via PackageReference.|

  1) Save the project file.
      
  1) Reload the project.
  
  1) Exclude from the project any files that should not be included.
          
  1) Build and resolve any errors.


### Copy and Configure Support Files

#### Solution Files

  - **[`gulpfile.js`](nugetFiles/gulpfile.js)**  
    Gulp configuration file with commands for compiling, testing, building, and publishing the package.

  - **[`package.json`](nugetFiles/package.json)**  
    Package configuration including package name, version, and Project Registry.

    - Set **&lt;LibraryName&gt;** in **name** and **version** properties.
    - Set **publishConfig** for the `gulp set-source` command.
      - **source** - Nuget feed source.
      - **registry** - Registry URL.

  - **`README.md`**  
    Markdown file describing the package. There are no special requirements for this file.


#### Library Project Files

  - **[`Build.targets.tt`](nugetFiles/Build.targets.tt)**  
    [T4 text template][t4-templates] creates `Build.targets` file added to `.nupkg` file to copy
    the appropriate binaries to the output folder for the Release or Debug build.

  - **[`Package.targets`](nugetFiles/Package.targets)**
    Included by the project file, this file contains the canned configuration for NuGet package builds.

  - **[`Version.targets`](nugetFiles/Version.targets)**
    Included by `Package.targets`, this file contains the library version and is updated from 
    `package.json` using the `npm version` command.

    
### Install Support Packages

Perform all commands listed from the Solution folder.

 1) Initialize [.NET CLI tools environment][dotnet-tools] and install [dotnet-t4].
       
    ```
    dotnet new tool-manifest  
    dotnet tool install --local dotnet-t4 --version 2.2.1
    ```  
    - *Version 2.2.1 is the latest as of this writing.  
      .NET Framework 5.0 is the oldest framework supported but the process works with this 
      version and Framework 4.5.2*
 
 1) Install [SourceLink][source-link] support.
     
    - GitHub: `dotnet add package Microsoft.SourceLink.GitHub`
    - GitLab: `dotnet add package Microsoft.SourceLink.GitLab`
      - *For source code access to a private repo in GitLab requires the use of a proxy server
         like [GitlabProxy](https://gitlab.com/slcon/pub/repo/gitlabproxy).
 

### Install `Tests` project for unit tests (optional)      
     
```
dotnet new mstest -lang C# -o Tests`
dotnet sln add Tests/Tests.csproj
cd Tests
dotnet add reference ../MyLibrary/MyLibrary.csproj
cd ..
```

 
### Install **`Docs`** project for Doxygen website (optional)
         
In **Solution Explorer**, add a new **Shared Project** called **Docs** in a `Docs` subfolder.
 
*Configuring [DoxyGen] is beyond the scope of this document.*


## Building and Publishing

Publishing a package to a [nuget registry][hosting-packages] is done using the **`gulp publish`** 
command. It can then be installed using the Nuget [Package Manager][package-manager], [NuGet CLI], or 
[.NET CLI][dotnet-cli].


#### Preparation

  1) Set the endpoint for the `@slcpub` [package registry][slcpub-registry] using [npm].
  1) Install development dependencies:
     ```bash
     npm install
     ```

#### Build Commands

**`gulp set-source`** takes input of a personal access token, providing read/write access to the 
package registry, and configures a package source in the user's `nuget.config` file for publishing 
the NuGet package to the registry.

**`gulp build`** builds both the **Release and Debug versions** of the library and **updates 
`version.targets` with `package.json#version`**.

[**`npm version`**][npm version] updates **`package.json#version`**, runs **`gulp build`**, commits to
the local repo, and creates a tag for the version.

**`gulp pack`** is run after `npm version`. It builds the NuGet package `.nupkg` file containing
both builds created in `gulp build`.

**`gulp publish`** is run after **`gulp pack`** and it publishes the `.nupkg` file to the package
registry endpoint as defined in **`package.json#publishConfig#registry`**.


#### TL;DR

After testing is complete and the package is ready to publish:

1) If the Package Source has not been configured or the Access Token has been changed,  
   Run **`gulp set-source`** to set the package source for publishing.

1) Run [**`npm version`**][npm version]
   * *preversion*: Runs **`gulp test`** to run the library tests,
   * Updates the version number in `package.json`,
   * *version*: 
     * Runs **`gulp build`**
       * Updates **`Version.targets`** from **`package.json`** to get the version number, and
       * Builds the library.
     * Runs [**`git add`**](https://git-scm.com/docs/git-add) to stage `Version.targets` for commit,
   * Commits changes and creates a version tag.<br/>

1) Run **`gulp push`** to update the GitLab repository with the new version.

1) (Optional) Run **`gulp build-sense`** to replace Intellisense XML file created by MSBuild with
   one created from Doxygen output.

1) Run **`gulp pack`** to build the NuGet package `.nupkg` file.

1) Run **`gulp set-source`** to add a NuGet source for publishing to the package registry. This will require
   personal access token credentials.

1) Run **`gulp publish`** to publish the package to the package registry.


## References

  - [What is NuGet?][NuGet]
  - [Source Link][source-link]
  - [Doxygen]
  - [Intellisense]
  - [Visual Studio Package Manager][package-manager]
  - [.NET CLI][dotnet-cli]
  - [NuGet CLI]
  - [npm version]
  - [Hosting NuGet Feeds][hosting-packages]
    - [GitHub][github-registry]
      - [Personal Access Tokens][github-personal access token]
    - [GitLab][gitlab-registry]
      - [Personal Access Tokens][gitlab-personal access token]
      - [Deploy Tokens][gitlab-deploy token]


[NuGet]:                        https://docs.microsoft.com/en-us/nuget/what-is-nuget
[msbuild-package]:              https://learn.microsoft.com/en-us/nuget/create-packages/creating-a-package-msbuild
[gulp]:                         https://gulpjs.com/docs/en/getting-started/javascript-and-gulpfiles
[npm]:                          https://docs.npmjs.com/about-npm
[semver]:                       https://semver.org/
                                
[pdb-files]:                    https://docs.microsoft.com/en-us/visualstudio/debugger/specify-symbol-dot-pdb-and-source-files-in-the-visual-studio-debugger
[symbol-servers]:               https://docs.microsoft.com/en-us/windows/win32/debug/symbol-servers-and-symbol-stores
[vs-symbol-servers]:            https://docs.microsoft.com/en-us/visualstudio/debugger/specify-symbol-dot-pdb-and-source-files-in-the-visual-studio-debugger#configure-location-of-symbol-files-and-loading-options
[vs-source-servers]:            https://docs.microsoft.com/en-us/visualstudio/debugger/specify-symbol-dot-pdb-and-source-files-in-the-visual-studio-debugger#other-symbol-options-for-debugging
[vs-source-file-paths]:         https://docs.microsoft.com/en-us/visualstudio/debugger/specify-symbol-dot-pdb-and-source-files-in-the-visual-studio-debugger#use-the-no-symbols-loadedno-source-loaded-pages
[source-link]:                  https://docs.microsoft.com/en-us/dotnet/standard/library-guidance/sourcelink
[intellisense]:                 https://learn.microsoft.com/en-us/visualstudio/ide/using-intellisense
[doxygen]:                      https://www.doxygen.nl/
                                
[packages.config]:              https://docs.microsoft.com/en-us/nuget/reference/packages-config
[PackageReference]:             https://docs.microsoft.com/en-us/nuget/consume-packages/package-references-in-project-files
[sdk-style]:                    https://docs.microsoft.com/en-us/dotnet/core/project-sdk/overview
[demystify-sdk]:                https://dansiegel.net/post/2018/08/21/demystifying-the-sdk-project
                                
[dotnet-cli]:                   https://learn.microsoft.com/en-us/dotnet/core/tools/
[dotnet-download]:              https://dotnet.microsoft.com/en-us/download/dotnet
[dotnet-tools]:                 https://learn.microsoft.com/en-us/dotnet/core/tools/global-tools
[install-package]:              https://docs.microsoft.com/en-us/nuget/quickstart/install-and-use-a-package-in-visual-studio
[t4-templates]:                 https://learn.microsoft.com/en-us/visualstudio/modeling/code-generation-and-t4-text-templates
[dotnet-t4]:                    https://www.nuget.org/packages/dotnet-t4/
[hosting-packages]:             https://learn.microsoft.com/en-us/nuget/hosting-packages/overview
[package-manager]:              https://learn.microsoft.com/en-us/nuget/consume-packages/install-use-packages-visual-studio
[slcpub-registry]:              https://gitlab.com/slcon/pub/registry
[npm version]:                  https://docs.npmjs.com/cli/v6/commands/npm-version
[nuget cli]:                    https://learn.microsoft.com/en-us/nuget/reference/nuget-exe-cli-reference
[gitlab-registry]:              https://docs.gitlab.com/ee/user/packages/nuget_repository/
[gitlab-personal access token]: https://docs.gitlab.com/ee/user/profile/personal_access_tokens.html#personal-access-tokens
[gitlab-deploy token]:          https://docs.gitlab.com/ee/user/project/deploy_tokens/index.html
[github-registry]:              https://docs.github.com/en/packages/working-with-a-github-packages-registry/working-with-the-nuget-registry
[github-personal access token]: https://docs.github.com/en/authentication/keeping-your-account-and-data-secure/creating-a-personal-access-token